'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _utils = require('./utils');

var _options = require('./options');

var resolvers = {};

resolvers[(0, _utils.generateMask)([_options.VALUE])] = (0, _utils.compose)(_utils.leftCurryTwice, _utils.resolveDeps)(_utils.identity);
resolvers[(0, _utils.generateMask)([_options.FUNCTION])] = (0, _utils.compose)(_utils.leftCurryTwice, _utils.resolveDeps)(_utils.partial);
resolvers[(0, _utils.generateMask)([_options.CONSTRUCTOR])] = (0, _utils.compose)(_utils.leftCurryTwice, _utils.resolveDeps)(_utils.instanciate);
resolvers[(0, _utils.generateMask)([_options.PROVIDER])] = (0, _utils.compose)(_utils.leftCurryTwice, _utils.resolveDeps)(_utils.invoke);

resolvers[(0, _utils.generateMask)([_options.TRANSIENT, _options.SINGLETON, _options.PROVIDER])] = (0, _utils.singletonify)(_utils.invoke);
resolvers[(0, _utils.generateMask)([_options.TRANSIENT, _options.CONSTRUCTOR, _options.SINGLETON])] = (0, _utils.singletonify)(_utils.instanciate);

resolvers[(0, _utils.generateMask)([_options.LAZY, _options.SINGLETON, _options.PROVIDER])] = (0, _utils.singletonify)(_utils.invoke, true);
resolvers[(0, _utils.generateMask)([_options.LAZY, _options.SINGLETON, _options.CONSTRUCTOR])] = (0, _utils.singletonify)(_utils.instanciate, true);

resolvers[(0, _utils.generateMask)([_options.EAGER, _options.SINGLETON, _options.PROVIDER])] = (0, _utils.singletonify)(_utils.invoke, true);
resolvers[(0, _utils.generateMask)([_options.EAGER, _options.SINGLETON, _options.CONSTRUCTOR])] = (0, _utils.singletonify)(_utils.instanciate, true);

// aliases
resolvers[(0, _utils.generateMask)([_options.INSTANCE])] = resolvers[(0, _utils.generateMask)([_options.VALUE])];

// backward compatibility
resolvers[(0, _utils.generateMask)([_options.PERSISTENT, _options.SINGLETON, _options.PROVIDER])] = resolvers[(0, _utils.generateMask)([_options.LAZY, _options.SINGLETON, _options.PROVIDER])];
resolvers[(0, _utils.generateMask)([_options.PERSISTENT, _options.CONSTRUCTOR, _options.SINGLETON])] = resolvers[(0, _utils.generateMask)([_options.LAZY, _options.CONSTRUCTOR, _options.SINGLETON])];

exports['default'] = resolvers;
module.exports = exports['default'];